<?php
namespace MyMenu\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;

use MyMenu\Services\JWT;
use MyMenu\Util\RequestHeader;

class Authenticator {
   private $crudService;
   protected $libUtilities;

    public function __construct($crudService, $libUtilities ) {
        $this->crudService  = $crudService;
        $this->libUtilities  = $libUtilities;
    }
    
    
    public function authenticator(Request $request, Response $response) {
        $token = RequestHeader::getKey("token", null);
        if($token) {
            $tokenData = JWT::getTokenData($token);
            if (isset($tokenData['NRUSUARIOAPP']) && isset($tokenData['DSEMAILUSUARIOAPP'])) {
                $user = $tokenData['NRUSUARIOAPP'];
                $email = $tokenData['DSEMAILUSUARIOAPP'];
                $cdfilial = $tokenData['CDFILIAL'];
                $conditions = array(
                    array(
                        "columnName" => "NRUSUARIOAPP",
                        "operator" => "=",
                        "value" => $user,
                    ),
                    array(
                        "columnName" => "DSEMAILUSUARIOAPP",
                        "operator" => "=",
                        "value" => $email,
                    ),
                );
                
                $resDataSet = $this->crudService->getFilteredDataSet('usuarioapp_login', $conditions, 1, 1);
                
                if (sizeof($resDataSet->getRows()) == 1) {
                    $userData = $resDataSet->getRows()[0];
                    $isNewUser = $userData['USUARIOATIVO'] === null;
                    if ($userData['USUARIOATIVO'] == 'S' || $isNewUser) {
                        $response->addDataSet(new DataSet('user', [true]));
                        $this->libUtilities->saveCollectedData($cdfilial,'MYMENU');
                    } else {
                        $response->addDataSet(new DataSet('user', [false]));
                    }
                }
            }
        } else {
            $response->addDataSet(new DataSet('user', [true]));
        }
    }
}
