function MyMenuCardapioController(ScreenService, templateManager, restEngine, LocalPlateDataService, MessageService) {
    var self = this;
    this.doNothing = function () {};
    this.onEnter = function (widget) {};
    
    function saveCons(data) {
        return restEngine.request("/consSave", {
            requestType: "Row",
            row: data
        });
    }
    
    function saveSrvCons(data) {
        return restEngine.request("/consSrvSave", {
            requestType: "Row",
            row: data
        });
    }

    function save(data) {
        return restEngine.request("/rateSave", {
            requestType: "Row",
            row: data
        });
    }

    this.resetBookMarking = function(widget) {
        widget.bookMarking = [];
        widget.reload();
    };
    
    this.backToLastWidget = function (widget) {
        let widgets = widget.container.widgets;
        let acwidget = widgets.indexOf(widget);

        widget.isVisible = false;

        let widgetToGo = widgets[acwidget - 1];

        widgetToGo.container.label = widgetToGo.servdata ? widgetToGo.servdata[widgetToGo.label] : null || widgetToGo.currentRow.servdata ? widgetToGo.currentRow.servdata[widgetToGo.label] : widgetToGo.label;

        widgetToGo.isVisible = true;
        widgetToGo.activate();
    };

    this.saveRateData = function () {

        let widget = templateManager.container.getActiveWidget();
        let dtfil = widget.dataSourceFilter.find(f => f.name === 'DTCARDAPIO').value;
        dtfil = dtfil === "@moment().format('DD/MM/YYYY')@" ? moment() : moment(dtfil, 'DD/MM/YYYY');

        let plate = widget.plateToRate;
        plate.NRUSUARIOAPP = getLocalVar('userData').NRUSUARIOAPP;
        plate.NRORG = getLocalVar('userData').NRORG;
        plate.VRAVALIACAOPRATO = plate.newAv;
        plate.DTCARDAPIO = dtfil.format('DD/MM/YYYY');

        save(plate).then(response => {
            if (getLocalVar('userData').isAnon && getLocalVar('userData').isAnon === true) {
                if (getLocalVar('lastRate')) {
                    let list = getLocalVar('lastRate');
                    let last = {
                        'CDPRATO': plate.CDPRATO,
                        'NRCARDAPIO': plate.NRCARDAPIO,
                        'CDTIPOPRAT': plate.CDTIPOPRAT,
                        'DATE': dtfil.format('DD/MM/YYYY')
                    };
                    list.push(last);
                    setLocalVar('lastRate', list);
                } else {
                    let last = {
                        'CDPRATO': plate.CDPRATO,
                        'NRCARDAPIO': plate.NRCARDAPIO,
                        'CDTIPOPRAT': plate.CDTIPOPRAT,
                        'DATE': dtfil.format('DD/MM/YYYY')
                    };
                    setLocalVar('lastRate', [last]);
                }
            }
            widget.reload();
            MessageService.showMessageByCode('MSG_RATED_WITH_SUCCESS', null, {type: 'success'});
        }).catch(error => {
            ScreenService.showMessage(error || error.message || 'Erro!');
        });
        widget.plateToRate = null;
    };

    this.resetTitle = () => templateManager.container.label = ScreenService.i18n('CARDÁPIO');

    function getFormatedPlateForCons(plate) {
        return {
            'CDPRATO': plate.CDPRATO,
            'CDFILCENTPME': plate.CDFILCENTPME,
            'CDTIPOCARD': plate.CDTIPOCARD,
            'NRCARDPME': plate.NRCARDPME,
            'CDDIETPAD': plate.CDDIETPAD,
            'CDFILIAL': plate.CDFILIAL,
            'CDSERVFILI': plate.CDSERVFILI,
            'NRCARDAPIO': plate.NRCARDAPIO,
            'NRSEQPRATCAR': plate.NRSEQPRATCAR,
            'CDFILAUXPRAT': plate.CDFILAUXPRAT,
            'DTCARDAPIO': plate.DTCARDAPIO,
            'CDTIPOPRAT': plate.CDTIPOPRAT,
            'IDCONSUMO': plate.IDCONSUMO,
            'NMUSUARIO': plate.NMUSUARIO,
            'HRCONSUMO': plate.HRCONSUMO,
            'NRORG': plate.NRORG,
            'DSCONSUMO': plate.DSCONSUMO || "",
            
            IDOPCCNFMES: plate.IDOPCCNFMES,
            IDCONCNFMES: plate.IDCONCNFMES,
            'CDREGISTROPESSOA': plate.CDREGISTROPESSOA,
            'NRAVALIACAOPRATO': plate.NRAVALIACAOPRATO
        };
    }

    function getFormatedServiceForCons(service) {
        return {
            'IDCONSUMO': service.IDCONSUMO,
            'DTCARDAPIO': service.DTCARDAPIO,
            'CDFILIAL': service.CDFILIAL,
            'CDSERVFILI': service.CDSERVFILI,
            'CDTIPOCARD': service.CDTIPOCARD,
            'NMUSUARIO': service.NMUSUARIO,
            'HRCONSUMO': service.HRCONSUMO,
            'NRORG': service.NRORG,
            'CDREGISTROPESSOA': service.CDREGISTROPESSOA,
            'DSCONSUMO': service.DSCONSUMO,
            'NRLOCALPESQ': service.NRLOCALPESQ,
            'NRAVALIACAOSERVICO': service.NRAVALIACAOSERVICO
        };
    }

    function editLocalConsData(plate) {
        let savedCons = getLocalVar('savedCons');
        if (savedCons) {
            let consToUpdate = savedCons.find(sc => sc.CDPRATO == plate.CDPRATO && sc.CDFILCENTPME == plate.CDFILCENTPME && sc.CDTIPOCARD == plate.CDTIPOCARD && sc.NRCARDPME == plate.NRCARDPME && sc.CDDIETPAD == plate.CDDIETPAD && sc.CDFILIAL == plate.CDFILIAL && sc.CDSERVFILI == plate.CDSERVFILI && sc.NRCARDAPIO == plate.NRCARDAPIO && sc.NRSEQPRATCAR == plate.NRSEQPRATCAR && sc.CDFILAUXPRAT == plate.CDFILAUXPRAT && sc.CDPRATO == plate.CDPRATO && sc.DTCARDAPIO == plate.DTCARDAPIO && sc.CDTIPOPRAT == plate.CDTIPOPRAT && sc.NRORG == plate.NRORG);
            if (consToUpdate) {
                consToUpdate.IDCONSUMO = plate.IDCONSUMO;
                consToUpdate.NMUSUARIO = plate.NMUSUARIO;
                consToUpdate.HRCONSUMO = plate.HRCONSUMO;
                consToUpdate.CDREGISTROPESSOA = plate.CDREGISTROPESSOA;
                consToUpdate.NRAVALIACAOPRATO = plate.NRAVALIACAOPRATO;
            } else {
                savedCons.push(getFormatedPlateForCons(plate));
            }
        } else {
            savedCons = [];
            savedCons.push(getFormatedPlateForCons(plate));
        }
        setLocalVar('savedCons', savedCons);
    }

    function editLocalSrvConsData(service) {
        let savedCons = getLocalVar('savedSrvCons');
        if (savedCons) {
            let consToUpdate = savedCons.find(sc => sc.CDFILIAL == service.CDFILIAL && sc.CDSERVFILI == service.CDSERVFILI && sc.CDTIPOCARD == service.CDTIPOCARD && sc.DTCARDAPIO == service.DTCARDAPIO && sc.NRORG == service.NRORG);
            if (consToUpdate) {
                consToUpdate.IDCONSUMO = service.IDCONSUMO;
                consToUpdate.NMUSUARIO = service.NMUSUARIO;
                consToUpdate.HRCONSUMO = service.HRCONSUMO;
                consToUpdate.CDREGISTROPESSOA = service.CDREGISTROPESSOA;
                consToUpdate.DSCONSUMO = service.DSCONSUMO;
                consToUpdate.NRLOCALPESQ = service.NRLOCALPESQ;
                consToUpdate.NRAVALIACAOSERVICO = service.NRAVALIACAOSERVICO;
            } else {
                savedCons.push(getFormatedServiceForCons(service));
            }
        } else {
            savedCons = [];
            savedCons.push(getFormatedServiceForCons(service));
        }
        setLocalVar('savedSrvCons', savedCons);
    }

    function saveIDCONCNFMES(plate) {
        let savedIDCONCNFMES = getLocalVar('IDCONCNFMESLIST');
        if (plate.IDCONCNFMES == 'S') {
            if (savedIDCONCNFMES) {
                savedIDCONCNFMES = savedIDCONCNFMES.filter(sicm => !(plate.CDTIPOPRAT == sicm.CDTIPOPRAT && plate.NRCARDAPIO == sicm.NRCARDAPIO && plate.CDPRATO == sicm.CDPRATO));
                if (plate.IDCONSUMO == 'S') {
                    savedIDCONCNFMES.push(plate);
                }
            } else {
                savedIDCONCNFMES = [];
                savedIDCONCNFMES.push(plate);
            }
        }
        setLocalVar('IDCONCNFMESLIST', savedIDCONCNFMES);
    }

    this.deleteConsData = function () {
        let widget = templateManager.container.getActiveWidget();
        const isAnon = getLocalVar('userData').isAnon;
        let plates = [];
        plates = angular.copy(widget.dataSource.data.filter((data) => data.IDCONSUMO == 'S'));
        
        plates.forEach((plate, key) => {
            plate.IDCONSUMO = 'N';
            plate.NRORG = getLocalVar('userData').NRORG;
            plate.isAnon = isAnon;
            plate.NRUSUARIOAPP = isAnon ? null : getLocalVar('userData').NRUSUARIOAPP;
            plate.HRCONSUMO = plate.isAnon ? null : plate.HRCONSUMO.replace(':', '');
            plate.DTCARDAPIO = plate.DTCARDAPIO === "@moment().format('DD/MM/YYYY')@" ? moment().format('DD/MM/YYYY') : plate.DTCARDAPIO;
            if (plate.isAnon) {
                LocalPlateDataService.reloadCache();
                const localPlate = LocalPlateDataService.findPlate(plate);
                if(localPlate)
                    plates[key] = Object.assign(plate, localPlate);
                plate.IDCONSUMO = 'N';
                editLocalConsData(plate);
            }
            saveIDCONCNFMES(plate);
        });
        
        saveCons(plates).then(() => {
            if(isAnon){
                plates.forEach((plate, key) => {
                    plate.NRAVALIACAOPRATO = null;
                    editLocalConsData(plate);
                });
            }
            MessageService.successNotificationByCode('MSG_CANCEL_RESERVATION');
            //Atualiza cache de pratos
            LocalPlateDataService.reloadCache();
            widget.reload();
        }).catch((error) => {
            if(isAnon){
                plates.forEach((plate, key) => {
                    plate.IDCONSUMO = 'S';
                    editLocalConsData(plate);
                    saveIDCONCNFMES(plate);
                });
            }
            LocalPlateDataService.reloadCache();
            widget.reload();
            self.trataErrosReserva(error);
        });
    };

    this.saveConsData = function () {
        let widget = templateManager.container.getActiveWidget();
        let plates = widget.bookMarking;

        if(plates && plates.length > 0) {
            const nmTpPratoCons = this.checkCons(widget);
            if(nmTpPratoCons == '') {
                plates.forEach((plate) => {
                    plate.NRORG = getLocalVar('userData').NRORG;
                    plate.isAnon = getLocalVar('userData').isAnon;
                    plate.NRUSUARIOAPP = getLocalVar('userData').NRUSUARIOAPP;
                    plate.HRCONSUMO = widget.dataBookmarking.HRCONSUMO.replace(':', '');
                    plate.DTCARDAPIO = plate.DTCARDAPIO === "@moment().format('DD/MM/YYYY')@" ? moment().format('DD/MM/YYYY') : plate.DTCARDAPIO;
                    if (plate.isAnon) {
                        plate.NRUSUARIOAPP = null;
                        LocalPlateDataService.reloadCache();
                        const localPlate = plate.IDCONSUMO === 'N' ?  LocalPlateDataService.findPlate(plate) : plate;
                        if(localPlate)
                            plate = Object.assign(localPlate, plate);
                        editLocalConsData(plate);
                    }
                    saveIDCONCNFMES(plate);
                });
                saveCons(plates).then((response) => {
                    if(response && response.dataset && response.dataset.data){
                        const plate = plates[0];
                        const isAnon = plate.isAnon;
                        const CDREGISTROPESSOA = plate.CDREGISTROPESSOA;
                        if (isAnon && response && response.dataset.data && response.dataset.data.length > 0) {
                            response.dataset.data.forEach((dataItem) => {
                                // Iterar sobre as propriedades de cada objeto dataItem
                                for (const key in dataItem) {
                                    if (dataItem.hasOwnProperty(key)) {
                                        const item = dataItem[key];
                                        editLocalConsData(item);
                                    }
                                }
                            });
                        } else if(!isAnon && getLocalVar('userData').CDREGISTROPESSOA == null){ /*atualiza o cpf do usuario para gravar nos dados do usuario em cache*/
                            let usr = angular.copy(getLocalVar('userData'));
                            usr.CDREGISTROPESSOA = CDREGISTROPESSOA;
                            setLocalVar('userData',usr);                        
                        }
                    }
                    MessageService.successNotificationByCode('MSG_CONFIRMED_RESERVATION');
                    widget.bookMarking = [];
                    widget.doReservation = false;
                    widget.showTimePickerModal = false;
                    //Atualiza cache de pratos
                    LocalPlateDataService.reloadCache();
                    widget.reload();
                    
                }).catch((error) => {
                    widget.bookMarking = [];
                    widget.doReservation = false;
                    widget.showTimePickerModal = false;
                    //Atualiza cache de pratos
                    LocalPlateDataService.reloadCache();
                    widget.reload();
                    self.trataErrosReserva(error);
                });
            } else {
                MessageService.showMessageByCode('MSG_SELECT_AT_LEAST_ONE', {PARAM: nmTpPratoCons}, {type:'error'});
                widget.doReservation = false;
                widget.showTimePickerModal = false;
                widget.dataBookmarking.HRCONSUMO = null;
            }
            
        }
    };

    this.checkCons = function(widget) {
        let nmTpPratoCons = '';
        let cdtpPrato = widget.dataSource.data.map((cdprato) => cdprato.CDTIPOPRAT);
        cdtpPrato = [...new Set(cdtpPrato)];
        cdtpPrato.forEach((cdprato) => {
            const arrObject = widget.dataSource.data.filter((data) => data.CDTIPOPRAT == cdprato && data.IDCONCNFMES == 'S');
            if(arrObject.length > 0) {
                const selectedPratCons = arrObject.filter((object) => object.IDCONSUMO == 'S');
                if (selectedPratCons.length == 0) {
                    nmTpPratoCons = arrObject[0].NMTIPOPRAT;
                    return;
                }
            }
        });
        return nmTpPratoCons;
    };

    this.saveSrvConsData = function () {
        const userData = getLocalVar('userData');
        let widget = templateManager.container.getActiveWidget();
        let servdata = widget.dataBookmarking;
        let dtfil = widget.dataSourceFilter.find(f => f.name === 'DTCARDAPIO').value;
        dtfil = dtfil === "@moment().format('DD/MM/YYYY')@" ? moment() : moment(dtfil, 'DD/MM/YYYY');
        servdata.DTCARDAPIO = dtfil.format('DD/MM/YYYY');

        servdata.NRORG = userData.NRORG;
        servdata.isAnon = userData.isAnon;
        servdata.NRUSUARIOAPP = userData.isAnon ? null : userData.NRUSUARIOAPP;

        if (servdata.isAnon) {
            if(servdata.IDCONSUMO === 'N'){
                let localServ = getLocalVar('savedSrvCons');
                if (localServ){ 
                    let foundServ = localServ.find(sc => sc.CDFILIAL == servdata.CDFILIAL && 
                                                         sc.CDSERVFILI == servdata.CDSERVFILI && 
                                                         sc.DTCARDAPIO == servdata.DTCARDAPIO && 
                                                         sc.NRORG == servdata.NRORG);
                    if (foundServ)            
                        servdata.NRAVALIACAOSERVICO = foundServ.NRAVALIACAOSERVICO;
                }
            }
        }
        saveSrvCons(servdata).then((response) => {
            if(servdata.IDCONSUMO === 'S'){
                if(servdata.isAnon){
                    if (response && response.dataset && response.dataset.data) {
                        servdata.NRAVALIACAOSERVICO = response.dataset.data[0];
                    } else {
                        servdata.NRAVALIACAOSERVICO = null;
                    }
                    editLocalSrvConsData(servdata);
                }else{
                    if (!userData.CDREGISTROPESSOA) {
                        setLocalVar('userData', { ...userData, CDREGISTROPESSOA: servdata.CDREGISTROPESSOA });
                    }
                }
            }else{
                if(servdata.isAnon){
                    servdata.NRAVALIACAOSERVICO = null;
                    editLocalSrvConsData(servdata);
                }
            }

            widget.dataBookmarking = null;
            widget.reload();
        }).catch((error) => {
            widget.dataBookmarking = null;
            widget.reload();
            self.trataErrosReserva(error);
        });
    };
    
    this.trataErrosReserva = function(erro) {
        if (erro && erro.data && erro.data.error) {
            const errorMessages = {
                'RESERVA_JA_REALIZADA_USUARIO': 'RESERVA_JA_REALIZADA_USUARIO',
                'RESERVA_JA_RECEBIDA_USUARIO': 'RESERVA_JA_RECEBIDA_USUARIO',
                'CPF_JA_CADASTRADO_USUARIO':'CPF_JA_CADASTRADO_USUARIO'
            };
    
            for (const [key, value] of Object.entries(errorMessages)) {
                if (erro.data.error.includes(key)) {
                    MessageService.showMessageByCode(value, null, {type:'error'});
                    break;
                }
            }
        }
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register('MyMenuCardapioController', MyMenuCardapioController);
});
