window.templateUrl = "./bower_components/zeedhi-frontend/templates/dyman/";
window.serviceUrl = "/backend/index.php";
window.projectCorp = true;
window.projectId = 9999;
window.keepTitle = true;
window.showFullOperatorWindow = true;
window.metadataUrl = "assets";

var pkg = {
    "product": "./assets",
    "modules": "../../../mobile/assets",
	"zeedhiFramework": "./bower_components/zeedhi-frontend/assets",
	"zhuacl": "./bower_components/zhuaclfrontend/assets",
	"zhulog": "./bower_components/zhulog/assets",
	"lib": "./bower_components/tek-libraries",

	"zh-preferences": "./bower_components/zh-preferences/dist/assets/",
	"zh-filter-preferences": "./bower_components/zh-filter-preferences/dist/assets/",
	"zh-layout-preferences": "./bower_components/zh-layout-preferences/dist/assets/",
	"zh-view-preferences": "./bower_components/zh-view-preferences/dist/assets/"
};

var metadataUrls = [];
var serviceUrls = [];

var pkgBaseUrls = {
    default: window.serviceUrl,
    product: window.location.href.search("modules") !== -1 ? "/backend/index.php" : window.serviceUrl
};

var getRealBaseKey = function(keyPkg) {
    var hasAlias = false;
	var module = window.location.pathname.replace(/\//g, "");
    return hasAlias ? pkgBaseUrls.hasOwnProperty(keyPkg) ? keyPkg : module ? module : 'product' : keyPkg === 'product' ? keyPkg : 'default';
};

for (var key in pkg) {
    metadataUrls.push({
        "package": key,
        "baseUrl": pkg[key]
    });
    var keyPkg = key.split('_')[0];
    var realBaseKey = getRealBaseKey(keyPkg);
	var uri = pkgBaseUrls[realBaseKey];
	if (keyPkg.indexOf('-preferences') != -1) {
        uri += '/zh-preferences';
    }
	serviceUrls.push({
        "package": key,
		"baseUrl": uri
	});
}

var baseProductLocation = window.location.origin;
if(window.serviceUrl.indexOf('service') != -1) {
    if(window.location.pathname.indexOf('modules') != -1) {
        baseProductLocation += window.location.pathname.split('modules')[0] + '/mobile';
    } else {
        baseProductLocation += window.location.pathname;
    }
}

window.templateUrls = window.templateUrls || [];
window.templateUrls.push(
    {
        package: "mymenu",
        baseUrl: "assets/templates/"
    },
    {
        package: "zh-customizations-service",
        baseUrl: "bower_components/zh-customizations-service/src/templates/"
    },
    {
        package: "rui-fields",
        baseUrl: "bower_components/red-ui-fields/dist/templates/"
    },
    {
        package: "rui-footer",
        baseUrl: "bower_components/red-ui-footer/dist/templates/"
    },
    {
        package: "rui-header",
        baseUrl: "bower_components/red-ui-header/dist/templates/"
    },
    {
        package: "rui-list",
        baseUrl: "bower_components/red-ui-list/dist/templates/"
    },
    {
        package: "rui-sidenav",
        baseUrl: "bower_components/red-ui-sidenav/dist/templates/"
    }
);

window.customFields = [
    {
        template: "mymenu#fields/select-native.html",
        viewTemplate: "mymenu#fields/select-native.html"
    },
    {
        template: "mymenu#select-multiple/select-multiple.html",
        viewTemplate: "mymenu#select-multiple/select-multiple.html"
    },
    {
        template: "mymenu#fields/top-button.html",
        viewTemplate: "mymenu#fields/top-button.html"
    },
    {
        template: "mymenu#fields/facebook-button.html",
        viewTemplate: "mymenu#fields/facebook-button.html"
    },
    {
        template: "mymenu#fields/language-button.html",
        viewTemplate: "mymenu#fields/language-button.html"
    }
];

window.applicationVersion = "2.0.0";
window.baseProductLocation = baseProductLocation;
window.lang = "pt_br";
moment.locale(window.lang);
window.docsUrl = "../bower_components/zeedhi-frontend/docs/dyman/";
window.metadataUrls = metadataUrls;
window.serviceUrls = serviceUrls;
window.qrcodebaseURL = "/backend/index.php";
window.fileServerPath = localStorage.getItem('fileServerURL') || null;
window.defaultUserImageUrl = baseProductLocation + "/assets/images/user.jpg";
window.undefinedImage = baseProductLocation + "/assets/images/undefinedImage.jpg";
window.cssUrl = "../../../mobile/assets/css/tecfood.css?v=2.0.0";
window.cssStyle = "tecfood";
window.inDeveloperMode = false;
window.useZhuAcl = true;


var CustomFieldRegister = function (decodeTemplateFieldService, DecodeValueFieldService) {
    window.customFields.forEach(field => {
        decodeTemplateFieldService.registerViewTemplate(field.template, field.viewTemplate);
        DecodeValueFieldService.registerCustomViewTemplate(field.template, field.viewTemplate);
    });
};
Configuration(function (ContextRegister) {
    if (window.customFields) {
        ContextRegister.register('CustomFieldRegister', CustomFieldRegister);
    }
});